; 
    include \masm32\include\masm32rt.inc
; 

comment * -----------------------------------------------------
                        Build this  template with
                       "CONSOLE ASSEMBLE AND LINK"
        ----------------------------------------------------- *

    include \masm32\include\winmm.inc
    includelib \masm32\lib\winmm.lib

    .data?
      reference dd ?
      iteration dd ?

    .code

start:
   
; 

    call main
    inkey
    exit

; 

main proc

    cls

    push esi

    invoke timeBeginPeriod,1        ; set resolution to 1

    mov esi, 1000

    mov reference, rv(timeGetTime)

  @@:
    mov iteration, rv(timeGetTime)  ; get the curent time
    sub eax, reference              ; subtract the reference from it
    print str$(eax),13,10           ; output the duration diference here
    add iteration, 10               ; add the required interval to "iteration"
    invoke SleepEx,9,0              ; yield to the OS for almost the entire interval
    call spinlock                   ; call the spinlock proc to finally trim the time
    sub esi, 1
    jnz @B

    invoke timeEndPeriod,1

    pop esi

    ret

main endp

; 

  spinlock:
    invoke timeGetTime              ; keep testing curent time until it
    .if eax < iteration             ; matches "iteration"
      jmp spinlock
    .endif
    retn

; 

end start
